listofbad = {}
numberOfBad = 1
badImg = love.graphics.newImage("Graphics/Bad Guy.png")
require "wall"
require "bump"
require "player"

function createBad(x, y)
  bad = {}
  
  bad.x = x
	bad.y = y
 	bad.width = 17
	bad.height = 32
	bad.xdir = 0
	bad.ydir = 0
	bad.friction = 0
	bad.speed = 150
  bad.img = badImg
  bad.isBad = true
  
  --Sets direction
  math.randomseed(os.time()*numberOfBad)
  math.random()
  direction = math.random(4)
  
  if direction == 1 then
    bad.xdir = -1
    bad.ydir = -1
  end
  
  if direction == 2 then
    bad.xdir = -1
    bad.ydir = 1
  end
  
  if direction == 3 then
    bad.xdir = 1
    bad.ydir = -1
  end
  
  if direction == 4 then
    bad.xdir = 1
    bad.ydir = 1
  end
  
  table.insert(listofbad,numberOfBad,bad)
  numberOfBad = numberOfBad+1
    
end
function listofbad.draw()
  
  for i,v in ipairs(listofbad) do 
      
    love.graphics.draw(v.img,v.x,v.y)
      
  end
    
end
function listofbad.update(dt)
  
 listofbad.move(dt)
  
end

function listofbad.move(dt)  

 for i,v in ipairs(listofbad) do
    

  local badFilter = function(v, other)
    
    if other.isPlayer then return 'cross'
    
    elseif other.isWall then return 'bounce'
    
    end
  
  end
    
    --Movement
     
    local goalX = v.x + (v.speed*v.xdir*dt)
    local goalY = v.y + (v.speed*v.ydir*dt)
    
      local actualX, actualY, cols, len = world:move(v, goalX, goalY, badFilter)
        
      for i = 1, len do
        local col = cols[i]
        local other = col.other
      
        if other.isPlayer then
                            
          for i,v in ipairs(listofbad) do v.speed = 0 end
          for i,v in ipairs(listofsuperbad) do v.speed = 0 end
          for i,v in ipairs(listofbomb) do v.speed = 0 end
          
          playerKill()
                
        end
      
        if col.bounce and col.bounce.x > v.x then
      
          v.xdir = 1
      
        elseif col.bounce and col.bounce.x < v.x then
      
          v.xdir = -1
                 
        end
        
        if col.bounce and col.bounce.y > v.y then
      
          v.ydir = 1
      
        elseif col.bounce and col.bounce.y < v.y then
     
          v.ydir = -1
      
        end
      
      end
    
        v.x, v.y = actualX, actualY
    
  end

end
function listofbad.reset()
  for i,v in ipairs(listofbad) do
    world:remove(v)
  end
  
  for i=0, 1000 do rawset(listofbad, i, nil) end

  numberOfBad = 1
end