listofbomb = {}
numberOfBomb = 1
bombImg = love.graphics.newImage("Graphics/bomb.png")
require "wall"
require "bump"
require "player"

function createBomb(x, y)
  bomb = {}
  
  bomb.x = x
	bomb.y = y
 	bomb.width = 12
	bomb.height = 12
	bomb.xdir = 0
	bomb.ydir = 0
	bomb.friction = 0
	bomb.speed = 15
  bomb.img = bombImg
  bomb.isBomb = true
  
  --Sets direction
  math.randomseed(os.time()*numberOfBomb)
  math.random()
  direction = math.random(4)
  
  if direction == 1 then
    bomb.xdir = -1
    bomb.ydir = -1
  end
  
  if direction == 2 then
    bomb.xdir = -1
    bomb.ydir = 1
  end
  
  if direction == 3 then
    bomb.xdir = 1
    bomb.ydir = -1
  end
  
  if direction == 4 then
    bomb.xdir = 1
    bomb.ydir = 1
  end
  
  table.insert(listofbomb,numberOfBomb,bomb)
  numberOfBomb = numberOfBomb+1
    
end
function listofbomb.draw()
  
  for i,v in ipairs(listofbomb) do 
      
    love.graphics.draw(v.img,v.x,v.y)
      
  end
    
end
function listofbomb.update(dt)
  
 listofbomb.move(dt)
  
end

function listofbomb.move(dt)  

 for i,v in ipairs(listofbomb) do
    

  local bombFilter = function(v, other)
    
    if other.isPlayer then return 'cross'
    
    elseif other.isWall then return 'bounce'
    
    end
  
  end
    
    --Movement
     
    local goalX = v.x + (v.speed*v.xdir*dt)
    local goalY = v.y + (v.speed*v.ydir*dt)
    
      local actualX, actualY, cols, len = world:move(v, goalX, goalY, bombFilter)
        
      for i = 1, len do
        local col = cols[i]
        local other = col.other
      
        if other.isPlayer then
                            
          for i,v in ipairs(listofbad) do v.speed = 0 end
          for i,v in ipairs(listofsuperbad) do v.speed = 0 end
          for i,v in ipairs(listofbomb) do v.speed = 0 end
          
          playerKill()
                
        end
      
        if col.bounce and col.bounce.x > v.x then
      
          v.xdir = 1
      
        elseif col.bounce and col.bounce.x < v.x then
      
          v.xdir = -1
                 
        end
        
        if col.bounce and col.bounce.y > v.y then
      
          v.ydir = 1
      
        elseif col.bounce and col.bounce.y < v.y then
     
          v.ydir = -1
      
        end
      
      end
    
        v.x, v.y = actualX, actualY
    
  end

end
function listofbomb.reset()
  for i,v in ipairs(listofbomb) do
    world:remove(v)
  end
  
  for i=0, 10000 do rawset(listofbomb, i, nil) end

  numberOfBomb = 1
end