listofsuperbad = {}
numberOfSuperBad = 1
superbadImg = love.graphics.newImage("Graphics/super bad.png")
require "wall"
require "bump"
require "player"
require "bomb"

function createSuperBad(x, y)
  superbad = {}
  
  superbad.x = x
	superbad.y = y
 	superbad.width = 17
	superbad.height = 32
	superbad.xdir = 0
	superbad.ydir = 0
	superbad.friction = 0
	superbad.speed = 170
  superbad.img = superbadImg
  superbad.isSuperBad = true
  
  --Sets direction of movement to a random diagonal
  math.randomseed(os.time()*numberOfSuperBad)
  math.random()
  direction = math.random(4)
  
  if direction == 1 then
    superbad.xdir = -1
    superbad.ydir = -1
  end
  
  if direction == 2 then
    superbad.xdir = -1
    superbad.ydir = 1
  end
  
  if direction == 3 then
    superbad.xdir = 1
    superbad.ydir = -1
  end
  
  if direction == 4 then
    superbad.xdir = 1
    superbad.ydir = 1
  end
  
  table.insert(listofsuperbad,numberOfSuperBad,superbad)
  numberOfSuperBad = numberOfSuperBad+1
    
end
function listofsuperbad.draw()
  
  for i,v in ipairs(listofsuperbad) do 
      
    love.graphics.draw(v.img,v.x,v.y)
      
  end
    
end
function listofsuperbad.update(dt)
  
 listofsuperbad.move(dt)
  
end

function listofsuperbad.move(dt)  

 for i,v in ipairs(listofsuperbad) do
    

  local superbadFilter = function(v, other)
    
    if other.isPlayer then return 'cross'
    
    elseif other.isWall then return 'bounce'
    
    end
  
  end
    
    --Movement
     
    local goalX = v.x + (v.speed*v.xdir*dt)
    local goalY = v.y + (v.speed*v.ydir*dt)
    
      local actualX, actualY, cols, len = world:move(v, goalX, goalY, superbadFilter)
        
      for i = 1, len do
        local col = cols[i]
        local other = col.other
      
        if other.isPlayer then
                   
          --Halts movement of enemies
          for i,v in ipairs(listofsuperbad) do v.speed = 0 end
          for i,v in ipairs(listofbad) do v.speed = 0 end
          for i,v in ipairs(listofbomb) do v.speed = 0 end
          
          playerKill()
                
        end
        
      --Directs bouncing when hitting walls
        if col.bounce and col.bounce.x > v.x then
      
          v.xdir = 1
      
        elseif col.bounce and col.bounce.x < v.x then
      
          v.xdir = -1
                 
        end
        
        if col.bounce and col.bounce.y > v.y then
      
          v.ydir = 1
      
        elseif col.bounce and col.bounce.y < v.y then
     
          v.ydir = -1
      
        end
      
      --spawn a bomb when coluding with walls
        if col.bounce then
          
          local items, len = world:queryPoint(v.x+8, v.y+16)
          
          for i=1, len do
            
            if items[i].isWall ~= true then
              createBomb(v.x+5, v.y+16)
              world:add(listofbomb[numberOfBomb-1],listofbomb[numberOfBomb-1].x,listofbomb[numberOfBomb-1].y,listofbomb[numberOfBomb-1].width,listofbomb[numberOfBomb-1].height)
              
            end
            
          end
          
          
          
        end
      
      end
    
        v.x, v.y = actualX, actualY
        
  end

end
function listofsuperbad.reset()
  --removes the enermy from the physics then from the drawable sprites.
  for i,v in ipairs(listofsuperbad) do
    world:remove(v)
  end
  
  for i=0, 1000 do rawset(listofsuperbad, i, nil) end

  numberOfSuperBad = 1
end